package core.services;

import core.api.models.timemanager.taskSchedule.BasicTaskScheduleFieldInfo;
import core.entities.timemanager.BasicTaskSchedule;
import core.entities.timemanager.Task;
import core.repositories.timemanager.BasicTaskScheduleRepository;
import core.repositories.timemanager.TaskRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class TaskScheduleService {

    private final BasicTaskScheduleRepository basicTaskScheduleRepository;
    private final TaskRepository taskRepository;

    public TaskScheduleService(@Autowired BasicTaskScheduleRepository basicTaskScheduleRepository,
                               @Autowired TaskRepository taskRepository) {
        this.basicTaskScheduleRepository = basicTaskScheduleRepository;
        this.taskRepository = taskRepository;
    }

    public ServiceResult<BasicTaskSchedule> createBasicTaskSchedule(Task task, BasicTaskScheduleFieldInfo basicTaskScheduleFieldInfo) {
        BasicTaskSchedule basicTaskSchedule = new BasicTaskSchedule(task, basicTaskScheduleFieldInfo.getScheduleDate());
        task.getBasicTaskSchedules().add(basicTaskSchedule);
        basicTaskScheduleRepository.save(basicTaskSchedule);
        taskRepository.save(task);
        return new ServiceResult<>(basicTaskSchedule);
    }
}
